var delta_t, t0, t1, tReac;
var resol_t = 1; //resolução temporal em ms
var nBins = 50; //bins no histograma
var esc = 16; //escala do histograma
var hlim = 8; //limite superior do histograma
var dy = 25; //posição do histograma
var fim = false;
var descartado = false;
var dados = [], ordem = [];
var h = [];
var num = 0, soma = 0, soma2 = 0;
var media, despad;
var mediana, qinf, qsup, minimo, maximo;

function setup() {
  tela = createCanvas(400, 350);
  tela.background(220);
  tela.mousePressed(pararMedida);
  textSize(18);
  fill("black");
  botaoIni = createButton("Fazer medida");
  botaoIni.position(20, 20);
  botaoIni.size(100, 30);
  botaoIni.mousePressed(fazerMedida);
  for (let i = 0; i < nBins; i++) {
    h[i] = 0;
  }
}

function fazerMedida() {
  background(220); // limpa canvas
  fim = false;
  delta_t = random(2000, 6000); // sorteia tempo de espera
  medida();
}

function pararMedida() {
  fim = true;
}

async function medida() {
  text("Clique na tela quando a cor mudar.", 20, 100);
  await sleep(delta_t); //espera tempo aleatório
  background('orange'); //muda cor da tela
  t0 = millis();        //instante inicial
  while (!fim) {
    await sleep(resol_t);
  }
  t1 = millis();        //instante da reação
  tReac = t1 - t0; //tempo de reação
  
  if (tReac>resol_t && tReac<1000) {  
	descartado = false;
	dados = append(dados, tReac);  //insere medida nos dados
	bin = floor((nBins * tReac) / 1000); //insere no histograma
	h[bin] = h[bin] + 1;
	num = num + 1; 
	soma = soma + tReac;
	soma2 = soma2 + tReac**2;
  } 
  else {
	descartado = true;
  }
  
  if (num > 1) {
	media = soma/num;
	despad = sqrt(num/(num-1))*sqrt(soma2/num - media**2);
  }
  
  if (num > 2) {
	ordem = sort(dados, num);
	print(ordem);
	mediana = calcMediana(ordem);
	qinf = calcMediana(subset(ordem,0,ceil(num/2)));
	qsup = calcMediana(subset(ordem,floor(num/2),ceil(num/2)));
	minimo = min(dados);
	maximo = max(dados);
  }
  
  background(220); //limpa tela
  if (!descartado) {
	  text(join(["Tempo de reação:",str(round(tReac)/1000),"s"]," "), 140, 45);
  }
  else {
	  text(join(["Descartado:",str(round(tReac)/1000),"s"]," "), 140, 45);
  }
  
  text(join(["Número de medidas:",str(num)]," "), 20, 90);
  if (num > 1) {
	text(join(["Média:",str(round(media)/1000),"s"]," "), 20, 130);
	text(join(["Desvio padrão:",str(round(despad)/1000),"s"]," "), 20, 150);
  }
// Escreve quartis
//  if (num > 2) {
//	text(join(["Mediana:",str(round(mediana)/1000),"s"]," "), 20, 190);
//	text(join(["Intervalo interquartil: [",str(round(qinf)/1000)," s, ",str(round(qsup)/1000)," s]"],""), 20, 210);
//	text(join(["Intervalo total: [",str(round(minimo)/1000)," s, ",str(round(maximo)/1000)," s]"],""), 20, 230);
//  }
  
  histograma(); //desenha histograma

}

function calcMediana(dadosOrdenados){
	let n_dados = dadosOrdenados.length;
	let n_med = floor(n_dados/2);
	if (n_med != n_dados/2) {
		return dadosOrdenados[n_med];
	}
	else {
		return (dadosOrdenados[n_med-1] + dadosOrdenados[n_med])/2;
	}
}

function histograma(){
  if (max(h)>hlim) {
	hlim = 2*hlim;
	esc = esc/2;
  }
  fill("cyan");
  for (i = 0; i < nBins; i++) {
    let x = i * (width / nBins);
    let y = height - esc*h[i];
    rect(x, y-dy, width/nBins, esc*h[i]);
  }
  //escala
  for (i = 0; i <= nBins; i=i+5) {
    let xs = i * (width/nBins);
    let ys = height - dy;
	rect(xs,ys,0,4);
  }
  fill("black");
  textSize(14);
  text("0", 2, height-8); 
  text("1", width-10, height-8);
  text("0.5", width/2-10, height-8);
  textSize(18);
};

//Ver stackoverflow.com/questions/67221313/how-to-wait-in-p5-js
function sleep(tempo_ms) {
  return new Promise((resolve) => {
    setTimeout(resolve, tempo_ms);
  });
}
